# Don't try fancy stuff like debuginfo, which is useless on binary-only
# packages. Don't strip binary too
# Be sure buildpolicy set to do nothing
%define        __spec_install_post %{nil}
%define          debug_package %{nil}
%define        __os_install_post %{_dbpath}/brp-compress

%define 	__perl /usr/local/bin/perl
#%define 	pg_datadir %{_prefix}/main

#
# Opt Style Package.
%define	_prefix /usr/local/var/postgres/%{MajorVersion}
%define postgres_user	postgres
%define postgres_uid	26
%define postgres_group	postgres
%define postgres_gid	26
%define MajorVersion	9.0

Summary: Postgresql (UPENN)
Name: upenn-postgresql
Vendor: UPENN
Version: 9.0.23
Release: 14
License: BSD
Group: Development/Tools
Source0: ftp://ftp.postgresql.org/pub/source/v%{version}/postgresql-%{version}.tar.bz2
Source2: postgresql-9.0
Source3: diskchecker.pl
Source4: upenn-pg-conf-templates.tar
URL: http://postgresql.org/
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root
#BuildArch: noarch
Prefix: %{_prefix}
Provides: upenn-postgresql = %{version}-%{release}
Requires: upenn-perl
Requires: readline
Requires: upenn-openssl
BuildRequires: upenn-openssl
BuildRequires: readline-devel

%description
Postgresql

%prep

%setup -q -n postgresql-%{version}
cp %{SOURCE2} .
cp %{SOURCE3} .
( cd .. && rm -rf pg-upenn && mkdir pg-upenn && cd pg-upenn && tar xvf %{SOURCE4} )
#cd postgresql-%{version} 

%build
#LD_RUN_PATH=/usr/local/lib
#export LD_RUN_PATH
#	--with-libraries=/usr/local/lib64/perl5/5.10.0/x86_64-linux/CORE/libperl.so \
CFLAGS="-Wl,-rpath=/usr/local/lib" ./configure \
        --prefix=%{_prefix} \
        --enable-thread-safety \
        --with-openssl \
	--with-perl \
        --with-readline \
        --with-libs=/usr/local/lib \
        --with-includes=/usr/local/include
make all
make -C doc man
make -C contrib/pg_standby all
make -C contrib/pg_archivecleanup all
make -C contrib/hstore all
make -C contrib/pgbench all
make -C contrib/pgcrypto all
make -C contrib/tsearch2 all
make -C contrib/pg_upgrade all
make -C contrib/pg_upgrade_support all
make -C src/tools/fsync

%install
rm -rf $RPM_BUILD_ROOT
make DESTDIR=$RPM_BUILD_ROOT install
make -C doc DESTDIR=$RPM_BUILD_ROOT install
make -C contrib/pg_standby DESTDIR=$RPM_BUILD_ROOT install
make -C contrib/pg_archivecleanup DESTDIR=$RPM_BUILD_ROOT install
make -C contrib/hstore DESTDIR=$RPM_BUILD_ROOT install
make -C contrib/pgbench DESTDIR=$RPM_BUILD_ROOT install
make -C contrib/pgcrypto DESTDIR=$RPM_BUILD_ROOT install
make -C contrib/tsearch2 DESTDIR=$RPM_BUILD_ROOT install
make -C contrib/pg_upgrade DESTDIR=$RPM_BUILD_ROOT install
make -C contrib/pg_upgrade_support DESTDIR=$RPM_BUILD_ROOT install
( cd src/tools/fsync && install -m 555 test_fsync $RPM_BUILD_ROOT/%{_prefix}/bin )
make -C contrib/pg_upgrade_support DESTDIR=$RPM_BUILD_ROOT install
install -d ${RPM_BUILD_ROOT}/%{_prefix}/share/upenn
install -m 440 ../pg-upenn/share/upenn/* ${RPM_BUILD_ROOT}/%{_prefix}/share/upenn

mkdir -p ${RPM_BUILD_ROOT}/etc/init.d
mkdir -p ${RPM_BUILD_ROOT}/usr/local/bin
mkdir -p  ${RPM_BUILD_ROOT}%{_prefix}
install -m 700 -d ${RPM_BUILD_ROOT}%{_prefix}/data/main
install -m 700 -d ${RPM_BUILD_ROOT}%{_prefix}/wal_archive/main
install -m 750 -d ${RPM_BUILD_ROOT}%{_prefix}/backups
install -m 555 %{SOURCE2} ${RPM_BUILD_ROOT}/etc/init.d
PG_VER=`perl -e '$v=shift; $v =~ s/(\d+)[.](\d+)/$1$2/; print $v' %{MajorVersion}`
# Create a psqlXX symlink in /usr/local/bin for convience 
( cd ${RPM_BUILD_ROOT}/usr/local/bin && ln -s ../var/postgres/%{MajorVersion}/bin/psql ./psql${PG_VER} )

%pre

if ! grep -q "^%{postgres_group}:" /etc/group; then
/usr/sbin/groupadd -g %{postgres_gid} %{postgres_group}
fi
# Get the gid from /etc/group in case it was created already.
GID=`perl -F: -lane 'print $F[2] if ($F[0] eq q{%{postgres_group}})' /etc/group`
HOME=/home/pgsql
if ! grep -q "^%{postgres_user}:" /etc/passwd; then
/usr/sbin/useradd -c "postgres role user" -g $GID -s /bin/bash -r -M -d ${HOME} -u %{postgres_uid} %{postgres_user}
install -m 750 -o %{postgres_user} -g %{postgres_gid} -d ${HOME}
fi

%clean
rm -rf RPM_BUILD_ROOT

%files
%defattr(-,root,root,-)
#%config(noreplace) %{_prefix}/data/*
%{_prefix}/bin/*
%{_prefix}/lib/*
%{_prefix}/include/*
%{_prefix}/share/*
##%{_prefix}/share/upenn/*
/etc/init.d/*
/usr/local/bin/*
%defattr(-,postgres,postgres,-)
%{_prefix}/data
%{_prefix}/backups
%changelog
* Tue Mar 31 2011 Garick Hamlin <ghamlin@isc.upenn.edu> 9.0-14
- Fix plperl breakage.
* Tue Mar 31 2011 Garick Hamlin <ghamlin@isc.upenn.edu> 9.0-12
- Bump to 9.0.23 / link to a upenn openssl package
* Tue Mar 31 2011 Garick Hamlin <ghamlin@isc.upenn.edu> 9.0-11
- Fixed Home directory creation bug. 
* Tue Mar 31 2011 Garick Hamlin <ghamlin@isc.upenn.edu> 9.0-10
- Fixed typo in user creation for postgres user.  
* Tue Mar 15 2011 Garick Hamlin <ghamlin@isc.upenn.edu> 9.0-9
- Added upenn configuration template files.
* Wed Mar 2 2011 Garick Hamlin <ghamlin@isc.upenn.edu> 9.0-8
- bumped version to 9.0.3
* Wed Mar 2 2011 Garick Hamlin <ghamlin@isc.upenn.edu> 9.0-7
- fixed init script, when running as postgresql user.
* Wed Oct 1 2010 Garick Hamlin <ghamlin@isc.upenn.edu> 9.0-6
- added diskchecker.pl, added test_fsync, fixed init script for HS.
* Wed Oct 1 2010 Garick Hamlin <ghamlin@isc.upenn.edu> 9.0-5
- Fixed symlink
* Wed Oct 1 2010 Garick Hamlin <ghamlin@isc.upenn.edu> 9.0-4
- Ug. Fixed install prefix
* Wed Sep 28 2010 Garick Hamlin <ghamlin@isc.upenn.edu> 9.0-2
- Added an init script.
* Wed Sep 28 2010 Garick Hamlin <ghamlin@isc.upenn.edu> 9.0-1
- First attempt at postgresql rpm from scratch
